#ifndef _H_D3534CE1991D11C794D4F2A3237B1EB2_Dqn_DCPS_H_
#define _H_D3534CE1991D11C794D4F2A3237B1EB2_Dqn_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Dqn_.h"


namespace turtlebot3_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class Dqn_Request_TypeSupportInterface;

            typedef Dqn_Request_TypeSupportInterface * Dqn_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Request_TypeSupportInterface> Dqn_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dqn_Request_TypeSupportInterface> Dqn_Request_TypeSupportInterface_out;


            class Dqn_Request_DataWriter;

            typedef Dqn_Request_DataWriter * Dqn_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Request_DataWriter> Dqn_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dqn_Request_DataWriter> Dqn_Request_DataWriter_out;


            class Dqn_Request_DataReader;

            typedef Dqn_Request_DataReader * Dqn_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Request_DataReader> Dqn_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Dqn_Request_DataReader> Dqn_Request_DataReader_out;


            class Dqn_Request_DataReaderView;

            typedef Dqn_Request_DataReaderView * Dqn_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Request_DataReaderView> Dqn_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dqn_Request_DataReaderView> Dqn_Request_DataReaderView_out;

            struct Dqn_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dqn_Request_, struct Dqn_Request_Seq_uniq_> Dqn_Request_Seq;
            typedef DDS_DCPSSequence_var < Dqn_Request_Seq> Dqn_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Dqn_Request_Seq> Dqn_Request_Seq_out;

            class  Dqn_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dqn_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Dqn_Request_TypeSupportInterface_var _var_type;

                static Dqn_Request_TypeSupportInterface_ptr _duplicate (Dqn_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dqn_Request_TypeSupportInterface () {};
                ~Dqn_Request_TypeSupportInterface () {};
            private:
                Dqn_Request_TypeSupportInterface (const Dqn_Request_TypeSupportInterface &);
                Dqn_Request_TypeSupportInterface & operator = (const Dqn_Request_TypeSupportInterface &);
            };

            class  Dqn_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dqn_Request_DataWriter_ptr _ptr_type;
                typedef Dqn_Request_DataWriter_var _var_type;

                static Dqn_Request_DataWriter_ptr _duplicate (Dqn_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dqn_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dqn_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Request_& instance_data) = 0;

            protected:
                Dqn_Request_DataWriter () {};
                ~Dqn_Request_DataWriter () {};
            private:
                Dqn_Request_DataWriter (const Dqn_Request_DataWriter &);
                Dqn_Request_DataWriter & operator = (const Dqn_Request_DataWriter &);
            };

            class  Dqn_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dqn_Request_DataReader_ptr _ptr_type;
                typedef Dqn_Request_DataReader_var _var_type;

                static Dqn_Request_DataReader_ptr _duplicate (Dqn_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Request_& instance) = 0;

            protected:
                Dqn_Request_DataReader () {};
                ~Dqn_Request_DataReader () {};
            private:
                Dqn_Request_DataReader (const Dqn_Request_DataReader &);
                Dqn_Request_DataReader & operator = (const Dqn_Request_DataReader &);
            };

            class  Dqn_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dqn_Request_DataReaderView_ptr _ptr_type;
                typedef Dqn_Request_DataReaderView_var _var_type;

                static Dqn_Request_DataReaderView_ptr _duplicate (Dqn_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Request_& instance) = 0;

            protected:
                Dqn_Request_DataReaderView () {};
                ~Dqn_Request_DataReaderView () {};
            private:
                Dqn_Request_DataReaderView (const Dqn_Request_DataReaderView &);
                Dqn_Request_DataReaderView & operator = (const Dqn_Request_DataReaderView &);
            };
            class Dqn_Response_TypeSupportInterface;

            typedef Dqn_Response_TypeSupportInterface * Dqn_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Response_TypeSupportInterface> Dqn_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dqn_Response_TypeSupportInterface> Dqn_Response_TypeSupportInterface_out;


            class Dqn_Response_DataWriter;

            typedef Dqn_Response_DataWriter * Dqn_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Response_DataWriter> Dqn_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dqn_Response_DataWriter> Dqn_Response_DataWriter_out;


            class Dqn_Response_DataReader;

            typedef Dqn_Response_DataReader * Dqn_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Response_DataReader> Dqn_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Dqn_Response_DataReader> Dqn_Response_DataReader_out;


            class Dqn_Response_DataReaderView;

            typedef Dqn_Response_DataReaderView * Dqn_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dqn_Response_DataReaderView> Dqn_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dqn_Response_DataReaderView> Dqn_Response_DataReaderView_out;

            struct Dqn_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Dqn_Response_, struct Dqn_Response_Seq_uniq_> Dqn_Response_Seq;
            typedef DDS_DCPSSequence_var < Dqn_Response_Seq> Dqn_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Dqn_Response_Seq> Dqn_Response_Seq_out;

            class  Dqn_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dqn_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Dqn_Response_TypeSupportInterface_var _var_type;

                static Dqn_Response_TypeSupportInterface_ptr _duplicate (Dqn_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dqn_Response_TypeSupportInterface () {};
                ~Dqn_Response_TypeSupportInterface () {};
            private:
                Dqn_Response_TypeSupportInterface (const Dqn_Response_TypeSupportInterface &);
                Dqn_Response_TypeSupportInterface & operator = (const Dqn_Response_TypeSupportInterface &);
            };

            class  Dqn_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dqn_Response_DataWriter_ptr _ptr_type;
                typedef Dqn_Response_DataWriter_var _var_type;

                static Dqn_Response_DataWriter_ptr _duplicate (Dqn_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dqn_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dqn_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Response_& instance_data) = 0;

            protected:
                Dqn_Response_DataWriter () {};
                ~Dqn_Response_DataWriter () {};
            private:
                Dqn_Response_DataWriter (const Dqn_Response_DataWriter &);
                Dqn_Response_DataWriter & operator = (const Dqn_Response_DataWriter &);
            };

            class  Dqn_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dqn_Response_DataReader_ptr _ptr_type;
                typedef Dqn_Response_DataReader_var _var_type;

                static Dqn_Response_DataReader_ptr _duplicate (Dqn_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Response_& instance) = 0;

            protected:
                Dqn_Response_DataReader () {};
                ~Dqn_Response_DataReader () {};
            private:
                Dqn_Response_DataReader (const Dqn_Response_DataReader &);
                Dqn_Response_DataReader & operator = (const Dqn_Response_DataReader &);
            };

            class  Dqn_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dqn_Response_DataReaderView_ptr _ptr_type;
                typedef Dqn_Response_DataReaderView_var _var_type;

                static Dqn_Response_DataReaderView_ptr _duplicate (Dqn_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dqn_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dqn_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dqn_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dqn_Response_& instance) = 0;

            protected:
                Dqn_Response_DataReaderView () {};
                ~Dqn_Response_DataReaderView () {};
            private:
                Dqn_Response_DataReaderView (const Dqn_Response_DataReaderView &);
                Dqn_Response_DataReaderView & operator = (const Dqn_Response_DataReaderView &);
            };
            class Sample_Dqn_Request_TypeSupportInterface;

            typedef Sample_Dqn_Request_TypeSupportInterface * Sample_Dqn_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Request_TypeSupportInterface> Sample_Dqn_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Request_TypeSupportInterface> Sample_Dqn_Request_TypeSupportInterface_out;


            class Sample_Dqn_Request_DataWriter;

            typedef Sample_Dqn_Request_DataWriter * Sample_Dqn_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Request_DataWriter> Sample_Dqn_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Request_DataWriter> Sample_Dqn_Request_DataWriter_out;


            class Sample_Dqn_Request_DataReader;

            typedef Sample_Dqn_Request_DataReader * Sample_Dqn_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Request_DataReader> Sample_Dqn_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Request_DataReader> Sample_Dqn_Request_DataReader_out;


            class Sample_Dqn_Request_DataReaderView;

            typedef Sample_Dqn_Request_DataReaderView * Sample_Dqn_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Request_DataReaderView> Sample_Dqn_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Request_DataReaderView> Sample_Dqn_Request_DataReaderView_out;

            struct Sample_Dqn_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Dqn_Request_, struct Sample_Dqn_Request_Seq_uniq_> Sample_Dqn_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dqn_Request_Seq> Sample_Dqn_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dqn_Request_Seq> Sample_Dqn_Request_Seq_out;

            class  Sample_Dqn_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dqn_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dqn_Request_TypeSupportInterface_var _var_type;

                static Sample_Dqn_Request_TypeSupportInterface_ptr _duplicate (Sample_Dqn_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dqn_Request_TypeSupportInterface () {};
                ~Sample_Dqn_Request_TypeSupportInterface () {};
            private:
                Sample_Dqn_Request_TypeSupportInterface (const Sample_Dqn_Request_TypeSupportInterface &);
                Sample_Dqn_Request_TypeSupportInterface & operator = (const Sample_Dqn_Request_TypeSupportInterface &);
            };

            class  Sample_Dqn_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dqn_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Dqn_Request_DataWriter_var _var_type;

                static Sample_Dqn_Request_DataWriter_ptr _duplicate (Sample_Dqn_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dqn_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dqn_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dqn_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Request_& instance_data) = 0;

            protected:
                Sample_Dqn_Request_DataWriter () {};
                ~Sample_Dqn_Request_DataWriter () {};
            private:
                Sample_Dqn_Request_DataWriter (const Sample_Dqn_Request_DataWriter &);
                Sample_Dqn_Request_DataWriter & operator = (const Sample_Dqn_Request_DataWriter &);
            };

            class  Sample_Dqn_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dqn_Request_DataReader_ptr _ptr_type;
                typedef Sample_Dqn_Request_DataReader_var _var_type;

                static Sample_Dqn_Request_DataReader_ptr _duplicate (Sample_Dqn_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Request_& instance) = 0;

            protected:
                Sample_Dqn_Request_DataReader () {};
                ~Sample_Dqn_Request_DataReader () {};
            private:
                Sample_Dqn_Request_DataReader (const Sample_Dqn_Request_DataReader &);
                Sample_Dqn_Request_DataReader & operator = (const Sample_Dqn_Request_DataReader &);
            };

            class  Sample_Dqn_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dqn_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Dqn_Request_DataReaderView_var _var_type;

                static Sample_Dqn_Request_DataReaderView_ptr _duplicate (Sample_Dqn_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dqn_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dqn_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Request_& instance) = 0;

            protected:
                Sample_Dqn_Request_DataReaderView () {};
                ~Sample_Dqn_Request_DataReaderView () {};
            private:
                Sample_Dqn_Request_DataReaderView (const Sample_Dqn_Request_DataReaderView &);
                Sample_Dqn_Request_DataReaderView & operator = (const Sample_Dqn_Request_DataReaderView &);
            };
            class Sample_Dqn_Response_TypeSupportInterface;

            typedef Sample_Dqn_Response_TypeSupportInterface * Sample_Dqn_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Response_TypeSupportInterface> Sample_Dqn_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Response_TypeSupportInterface> Sample_Dqn_Response_TypeSupportInterface_out;


            class Sample_Dqn_Response_DataWriter;

            typedef Sample_Dqn_Response_DataWriter * Sample_Dqn_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Response_DataWriter> Sample_Dqn_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Response_DataWriter> Sample_Dqn_Response_DataWriter_out;


            class Sample_Dqn_Response_DataReader;

            typedef Sample_Dqn_Response_DataReader * Sample_Dqn_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Response_DataReader> Sample_Dqn_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Response_DataReader> Sample_Dqn_Response_DataReader_out;


            class Sample_Dqn_Response_DataReaderView;

            typedef Sample_Dqn_Response_DataReaderView * Sample_Dqn_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dqn_Response_DataReaderView> Sample_Dqn_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dqn_Response_DataReaderView> Sample_Dqn_Response_DataReaderView_out;

            struct Sample_Dqn_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Dqn_Response_, struct Sample_Dqn_Response_Seq_uniq_> Sample_Dqn_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dqn_Response_Seq> Sample_Dqn_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dqn_Response_Seq> Sample_Dqn_Response_Seq_out;

            class  Sample_Dqn_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dqn_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dqn_Response_TypeSupportInterface_var _var_type;

                static Sample_Dqn_Response_TypeSupportInterface_ptr _duplicate (Sample_Dqn_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dqn_Response_TypeSupportInterface () {};
                ~Sample_Dqn_Response_TypeSupportInterface () {};
            private:
                Sample_Dqn_Response_TypeSupportInterface (const Sample_Dqn_Response_TypeSupportInterface &);
                Sample_Dqn_Response_TypeSupportInterface & operator = (const Sample_Dqn_Response_TypeSupportInterface &);
            };

            class  Sample_Dqn_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dqn_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Dqn_Response_DataWriter_var _var_type;

                static Sample_Dqn_Response_DataWriter_ptr _duplicate (Sample_Dqn_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dqn_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dqn_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dqn_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Response_& instance_data) = 0;

            protected:
                Sample_Dqn_Response_DataWriter () {};
                ~Sample_Dqn_Response_DataWriter () {};
            private:
                Sample_Dqn_Response_DataWriter (const Sample_Dqn_Response_DataWriter &);
                Sample_Dqn_Response_DataWriter & operator = (const Sample_Dqn_Response_DataWriter &);
            };

            class  Sample_Dqn_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dqn_Response_DataReader_ptr _ptr_type;
                typedef Sample_Dqn_Response_DataReader_var _var_type;

                static Sample_Dqn_Response_DataReader_ptr _duplicate (Sample_Dqn_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Response_& instance) = 0;

            protected:
                Sample_Dqn_Response_DataReader () {};
                ~Sample_Dqn_Response_DataReader () {};
            private:
                Sample_Dqn_Response_DataReader (const Sample_Dqn_Response_DataReader &);
                Sample_Dqn_Response_DataReader & operator = (const Sample_Dqn_Response_DataReader &);
            };

            class  Sample_Dqn_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dqn_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Dqn_Response_DataReaderView_var _var_type;

                static Sample_Dqn_Response_DataReaderView_ptr _duplicate (Sample_Dqn_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dqn_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dqn_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dqn_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dqn_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dqn_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dqn_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dqn_Response_& instance) = 0;

            protected:
                Sample_Dqn_Response_DataReaderView () {};
                ~Sample_Dqn_Response_DataReaderView () {};
            private:
                Sample_Dqn_Response_DataReaderView (const Sample_Dqn_Response_DataReaderView &);
                Sample_Dqn_Response_DataReaderView & operator = (const Sample_Dqn_Response_DataReaderView &);
            };
        }

    }

}

#endif
