#ifndef _H_D3534CE1991D11C794D4F2A3237B1EB2_Dqn__H_
#define _H_D3534CE1991D11C794D4F2A3237B1EB2_Dqn__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace turtlebot3_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  Dqn_Request_
            {
                ::DDS::Octet action_;
                ::DDS::Boolean init_;
            };

            typedef DDS_DCPSStruct_var<Dqn_Request_> Dqn_Request__var;
            typedef Dqn_Request_& Dqn_Request__out;

            struct  Dqn_Response_
            {
                struct _state__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Float, struct _state__seq_uniq_ > _state__seq;
                typedef DDS_DCPSSequence_var< _state__seq > _state__seq_var;
                typedef DDS_DCPSSequence_out< _state__seq > _state__seq_out;
                _state__seq state_;
                ::DDS::Float reward_;
                ::DDS::Boolean done_;
            };

            typedef DDS_DCPSStruct_var<Dqn_Response_> Dqn_Response__var;
            typedef DDS_DCPSStruct_out < Dqn_Response_> Dqn_Response__out;

            struct  Sample_Dqn_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::turtlebot3_msgs::srv::dds_::Dqn_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dqn_Request_> Sample_Dqn_Request__var;
            typedef Sample_Dqn_Request_& Sample_Dqn_Request__out;

            struct  Sample_Dqn_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::turtlebot3_msgs::srv::dds_::Dqn_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dqn_Response_> Sample_Dqn_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Dqn_Response_> Sample_Dqn_Response__out;

        }

    }

}

#endif /* _H_D3534CE1991D11C794D4F2A3237B1EB2_Dqn__H_ */
